#cwindowoff
#include "stdio.h"
#define  YMAX 22
#define  XMAX 70
#define  ROW  0
#define  COL  0
#define  FISH  '\35'   /*  */
#define  SHARK '\233'  /*  */
int  fish[XMAX][YMAX],fmove[XMAX][YMAX],
     shark[XMAX][YMAX],smove[XMAX][YMAX],starv[XMAX][YMAX];
int  hourx,minx,secx,hund;
int  pos[9],pos1[9];

int x,y,i,j,k,seed,*p2,*p3,*base,*top,tot;
int xmm1,ymm1,ymm1xx;
int *p,*p1;
int fbreed=6;
int sbreed=12;
int nfish=300;
int nshark=30;
int starve=6;

main(argc,argv)
int argc;
char *argv[];
{
    clrscrn();
    tot = XMAX*YMAX;
    time(&hourx,&minx,&secx,&hund);
    seed=hund*secx;
    x=srand(seed);
    x=0;
    for (i=0; i < argc-1; i++)
        pos[i]=atoi(argv[i+1]);
    pos[i]=(-1);
    x=0;
    if (pos[x] != (-1))
        nfish=pos[x++];
    if (pos[x] != (-1))
        nshark=pos[x++];
    if (pos[x] != (-1))
        fbreed=pos[x++];
    if (pos[x] != (-1))
        sbreed=pos[x++];
    if (pos[x] != (-1))
        starve=pos[x++];

    p=&fish;
    for (i=0; i < tot; ++i)  /* clear fish array */
        *p++=(-1);

    p=&starv;
    for (i=0; i < tot; ++i)  /* clear starve array */
        *p++=rand() % starve;

    for (i=0; i < nfish; ++i){  /* populate fish array */
        p = &fish;
        j = rand() % tot;
        p = p + j;
        if (*p == (-1))
            *p=rand() % fbreed;
        else
            --i;
        }

    p=&shark;
    for (i=0; i < tot; ++i)  /* clear shark array */
        *p++=(-1);

    for (i=0; i < nshark; ++i){  /* populate shark array */
        p = &fish;
        p1 = &shark;
        j = rand() % tot;
        p=p + j;
        p1=p1 + j;
        if (*p1 != (-1))
            i--;
        else {
            if (*p != (-1))
                *p=(-1);         /* fish was eaten */
            *p1=rand() % sbreed;
            }
        }

    while (nshark != 0) {
        poscrsr(ROW,COL);
        nfish=nshark=0;
        p=&fish;
        p1=&shark;

        for (i=1; i <= tot; ++i){
            if (*p != (-1)) {
                putchar(FISH);
                ++nfish;
                }
            else if (*p1 != (-1)) {
                putchar(SHARK);
                ++nshark;
                }
            else putchar(' ');

            if ((i % XMAX) == 0)
                putchar('\012');
            ++p;
            ++p1;
            }

        poscrsr(ROW+YMAX+2,COL);
        printf("Fish (%c) population =%4d  Shark (%c) population = %4d",
                FISH,nfish,SHARK,nshark);

        p=&smove;
        for (i=0; i < tot; ++i)  /* clear smove array */
            *p++=(-1);

        p=&shark;
        p1=&smove;
        p2=&fish;
        p3=&starv;
        ymm1=YMAX-1;
        xmm1=XMAX-1;
        ymm1xx=(YMAX-1)*XMAX;

        for (i=0; i < tot; ++i) {
            k=j=0;

            if ((*(p+i) != (-1)) && (*(p1+i) == (-1))) {

                x=1;
                ssub();

                for (x=xmm1; x <= XMAX; ++x)
                    ssub();

                for (x=ymm1xx; x <= ymm1xx+1; ++x)
                    ssub();

                x=tot-1;
                ssub();

                if (i % XMAX == 0) {
                    x=XMAX+1;
                    ssub();
                    x=2*XMAX-1;
                    ssub();
                    }

                else if (i % XMAX == XMAX-1) {
                    x=2*XMAX+1;
                    ssub();
                    x=ymm1xx-1;
                    ssub();

                    }
                else {
                    x=XMAX+1;
                    ssub();
                    x=ymm1xx-1;
                    ssub();
                    }


                pos[j]=i;
                pos1[k]=i;
                if (j)  {  /* j != 0 means eat a fish */
                    if (*(p+i) >= sbreed){
                        x=rand() % (j+1);
                        *(p+i)=0;
                        *(p1+i)=0;
                        *(p2+i)=(-1);
                        *(p3+i)=0;
                        *(p+pos[x])=0;
                        *(p1+pos[x])=0;
                        *(p2+pos[x])=(-1);
                        *(p3+pos[x])=0;
                        }
                    else{
                        x=rand() % (j+1);
                        j=*(p+i);
                        *(p+i)=(-1);
                        *(p+pos[x])=++j;
                        *(p3+i)=(-1);
                        *(p3+pos[x])=0;
                        *(p2+pos[x])=(-1);
                        *(p1+pos[x])=0;
                        }
                    }
                else {
                    if (*(p+i) >= sbreed){
                        x=rand() % (k+1);
                        *(p+i)=0;
                        *(p1+i)=0;
                        *(p3+i)=0;
                        *(p+pos1[x])=0;
                        *(p1+pos1[x])=0;
                        *(p3+pos1[x])=0;
                        }
                    else{
                        x=rand() % (k+1);
                        j=*(p+i);
                        *(p+i)=(-1);
                        *(p+pos1[x])=++j;
                        j=*(p3+i);
                        *(p3+i)=(-1);
                        *(p3+pos1[x])=++j;
                        *(p1+pos1[x])=0;
                        }
                    if (*(p3+pos1[x]) >= starve) {
                        *(p+pos1[x])=(-1);  /* starve him */
                        *(p3+pos1[x])=(-1);
                        }
                    if (*(p3+i) >= starve) {
                        *(p+i)=(-1);  /* starve him */
                        *(p3+i)=(-1);
                        }
                    }   /* else */
            }
        }
        p=&fmove;
        for (i=0; i < tot; ++i)  /* clear fmove array */
            *p++=(-1);

        p=&fish;
        p1=&fmove;
        p2=&shark;
        ymm1=YMAX-1;
        xmm1=XMAX-1;
        ymm1xx=(YMAX-1)*XMAX;

        for (i=0; i < tot; ++i) {
            j=0;

            if ((*(p+i) != (-1)) && (*(p1+i) == (-1))) {

                x=1;
                fsub();

                for (x=xmm1; x <= XMAX; ++x)
                    fsub();

                for (x=ymm1xx; x <= ymm1xx+1; ++x)
                    fsub();

                x=tot-1;
                fsub();

                if (i % XMAX == 0) {
                    x=XMAX+1;
                    fsub();
                    x=2*XMAX-1;
                    fsub();
                    }

                else if (i % XMAX == XMAX-1) {
                    x=2*XMAX+1;
                    fsub();
                    x=ymm1xx-1;
                    fsub();

                    }
                else {
                    x=XMAX+1;
                    fsub();
                    x=ymm1xx-1;
                    fsub();
                    }

                pos[j]=i;
                if (*(p+i) >= fbreed){
                    x=rand() % (j+1);
                    *(p+i)=0;
                    *(p+pos[x])=0;          /* new fish */
                    *(p1+i)=0;
                    *(p1+pos[x])=0;
                    }
                else{
                    x=rand() % (j+1);
                    j=*(p+i);
                    *(p+i)=(-1);
                    *(p+pos[x])=++j;
                    *(p1+pos[x])=0;
                    }
                }
            }

    } /* end while (nfish)  */
}


fsub()
{
    y=0;
    if ((y=i+x) >= tot)
        y%=tot;
        if (*(p+y) == (-1) && *(p2+y) == (-1)){
            pos[j]=y;
            ++j;
            }
}

ssub()
{
    y=0;
    if ((y=i+x) >= tot)
        y%=tot;
    if (*(p2+y) != (-1))  {
        pos[j]=y;      /* found a fish */
        ++j;
        }
    else if (*(p+y) == (-1))  {
        pos1[k]=y;
        ++k;
        }
}
